Index: branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncSearch.h
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncSearch.h	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibEncoder/TEncSearch.h	(revision 1200)
@@ -2,7 +2,7 @@
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
+ * granted under this license.
  *
-* Copyright (c) 2010-2015, ITU/ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -35,5 +35,4 @@
     \brief    encoder search class (header)
 */
-
 #ifndef __TENCSEARCH__
 #define __TENCSEARCH__
@@ -46,4 +45,5 @@
 #include "TLibCommon/TComTrQuant.h"
 #include "TLibCommon/TComPic.h"
+#include "TLibCommon/TComRectangle.h"
 #include "TEncEntropy.h"
 #include "TEncSbac.h"
@@ -58,4 +58,8 @@
 // Class definition
 // ====================================================================================================================
+
+static const UInt MAX_NUM_REF_LIST_ADAPT_SR=2;
+static const UInt MAX_IDX_ADAPT_SR=33;
+static const UInt NUM_MV_PREDICTORS=3;
 
 /// encoder search class
@@ -63,63 +67,56 @@
 {
 private:
-  TCoeff**        m_ppcQTTempCoeffY;
-  TCoeff**        m_ppcQTTempCoeffCb;
-  TCoeff**        m_ppcQTTempCoeffCr;
-  TCoeff*         m_pcQTTempCoeffY;
-  TCoeff*         m_pcQTTempCoeffCb;
-  TCoeff*         m_pcQTTempCoeffCr;
+  TCoeff**        m_ppcQTTempCoeff[MAX_NUM_COMPONENT /* 0->Y, 1->Cb, 2->Cr*/];
+  TCoeff*         m_pcQTTempCoeff[MAX_NUM_COMPONENT];
 #if ADAPTIVE_QP_SELECTION
-  Int**           m_ppcQTTempArlCoeffY;
-  Int**           m_ppcQTTempArlCoeffCb;
-  Int**           m_ppcQTTempArlCoeffCr;
-  Int*            m_pcQTTempArlCoeffY;
-  Int*            m_pcQTTempArlCoeffCb;
-  Int*            m_pcQTTempArlCoeffCr;
+  TCoeff**        m_ppcQTTempArlCoeff[MAX_NUM_COMPONENT];
+  TCoeff*         m_pcQTTempArlCoeff[MAX_NUM_COMPONENT];
 #endif
   UChar*          m_puhQTTempTrIdx;
-  UChar*          m_puhQTTempCbf[3];
-  
+  UChar*          m_puhQTTempCbf[MAX_NUM_COMPONENT];
+
   TComYuv*        m_pcQTTempTComYuv;
   TComYuv         m_tmpYuvPred; // To be used in xGetInterPredictionError() to avoid constant memory allocation/deallocation
-  Pel*            m_pSharedPredTransformSkip[3];
-  TCoeff*         m_pcQTTempTUCoeffY;
-  TCoeff*         m_pcQTTempTUCoeffCb;
-  TCoeff*         m_pcQTTempTUCoeffCr;
-  UChar*          m_puhQTTempTransformSkipFlag[3];
+
+  Char*           m_phQTTempCrossComponentPredictionAlpha[MAX_NUM_COMPONENT];
+  Pel*            m_pSharedPredTransformSkip[MAX_NUM_COMPONENT];
+  TCoeff*         m_pcQTTempTUCoeff[MAX_NUM_COMPONENT];
+  UChar*          m_puhQTTempTransformSkipFlag[MAX_NUM_COMPONENT];
   TComYuv         m_pcQTTempTransformSkipTComYuv;
 #if ADAPTIVE_QP_SELECTION
-  Int*            m_ppcQTTempTUArlCoeffY;
-  Int*            m_ppcQTTempTUArlCoeffCb;
-  Int*            m_ppcQTTempTUArlCoeffCr;
-#endif
+  TCoeff*         m_ppcQTTempTUArlCoeff[MAX_NUM_COMPONENT];
+#endif
+
 protected:
   // interface to option
   TEncCfg*        m_pcEncCfg;
-  
+
   // interface to classes
   TComTrQuant*    m_pcTrQuant;
   TComRdCost*     m_pcRdCost;
   TEncEntropy*    m_pcEntropyCoder;
-  
+
   // ME parameters
   Int             m_iSearchRange;
   Int             m_bipredSearchRange; // Search range for bi-prediction
   Int             m_iFastSearch;
-  Int             m_aaiAdaptSR[2][33];
+#if NH_MV
+  Bool            m_vertRestriction; 
+#endif 
+  Int             m_aaiAdaptSR[MAX_NUM_REF_LIST_ADAPT_SR][MAX_IDX_ADAPT_SR];
   TComMv          m_cSrchRngLT;
   TComMv          m_cSrchRngRB;
-  TComMv          m_acMvPredictors[3];
-  
+  TComMv          m_acMvPredictors[NUM_MV_PREDICTORS]; // Left, Above, AboveRight. enum MVP_DIR first NUM_MV_PREDICTORS entries are suitable for accessing.
+
   // RD computation
   TEncSbac***     m_pppcRDSbacCoder;
   TEncSbac*       m_pcRDGoOnSbacCoder;
   DistParam       m_cDistParam;
-  
+
   // Misc.
   Pel*            m_pTempPel;
   const UInt*     m_puiDFilter;
-  Int             m_iMaxDeltaQP;
-
-#if H_3D_VSO // M17
+
+#if NH_3D_VSO // M17
   TComYuv         m_cYuvRecTemp; 
 #endif
@@ -127,9 +124,11 @@
   // UInt            m_auiMVPIdxCost[AMVP_MAX_NUM_CANDS+1][AMVP_MAX_NUM_CANDS];
   UInt            m_auiMVPIdxCost[AMVP_MAX_NUM_CANDS+1][AMVP_MAX_NUM_CANDS+1]; //th array bounds
-  
+
+  TComMv          m_integerMv2Nx2N[NUM_REF_PIC_LIST_01][MAX_NUM_REF];
+
 public:
   TEncSearch();
   virtual ~TEncSearch();
-  
+
   Void init(  TEncCfg*      pcEncCfg,
             TComTrQuant*  pcTrQuant,
@@ -137,29 +136,32 @@
             Int           bipredSearchRange,
             Int           iFastSearch,
-            Int           iMaxDeltaQP,
+            const UInt    maxCUWidth,
+            const UInt    maxCUHeight,
+            const UInt    maxTotalCUDepth,
             TEncEntropy*  pcEntropyCoder,
             TComRdCost*   pcRdCost,
             TEncSbac***   pppcRDSbacCoder,
             TEncSbac*     pcRDGoOnSbacCoder );
-  
+
 protected:
-  
+
   /// sub-function for motion vector refinement used in fractional-pel accuracy
-  UInt  xPatternRefinement( TComPattern* pcPatternKey,
-                           TComMv baseRefMv,
-                           Int iFrac, TComMv& rcMvFrac );
-  
+  Distortion  xPatternRefinement( TComPattern* pcPatternKey,
+                                  TComMv baseRefMv,
+                                  Int iFrac, TComMv& rcMvFrac, Bool bAllowUseOfHadamard
+                                 );
+
   typedef struct
   {
-    Pel*  piRefY;
-    Int   iYStride;
-    Int   iBestX;
-    Int   iBestY;
-    UInt  uiBestRound;
-    UInt  uiBestDistance;
-    UInt  uiBestSad;
-    UChar ucPointNr;
+    Pel*        piRefY;
+    Int         iYStride;
+    Int         iBestX;
+    Int         iBestY;
+    UInt        uiBestRound;
+    UInt        uiBestDistance;
+    Distortion  uiBestSad;
+    UChar       ucPointNr;
   } IntTZSearchStruct;
-  
+
   // sub-functions for ME
   __inline Void xTZSearchHelp         ( TComPattern* pcPatternKey, IntTZSearchStruct& rcStruct, const Int iSearchX, const Int iSearchY, const UChar ucPointNr, const UInt uiDistance );
@@ -167,28 +169,26 @@
   __inline Void xTZ8PointSquareSearch ( TComPattern* pcPatternKey, IntTZSearchStruct& rcStrukt, TComMv* pcMvSrchRngLT, TComMv* pcMvSrchRngRB, const Int iStartX, const Int iStartY, const Int iDist );
   __inline Void xTZ8PointDiamondSearch( TComPattern* pcPatternKey, IntTZSearchStruct& rcStrukt, TComMv* pcMvSrchRngLT, TComMv* pcMvSrchRngRB, const Int iStartX, const Int iStartY, const Int iDist );
-  
-  Void xGetInterPredictionError( TComDataCU* pcCU, TComYuv* pcYuvOrg, Int iPartIdx, UInt& ruiSAD, Bool Hadamard );
+
+  Void xGetInterPredictionError( TComDataCU* pcCU, TComYuv* pcYuvOrg, Int iPartIdx, Distortion& ruiSAD, Bool Hadamard );
 
 public:
-  Void  preestChromaPredMode    ( TComDataCU* pcCU, 
-                                  TComYuv*    pcOrgYuv, 
-                                  TComYuv*    pcPredYuv );
-  Void  estIntraPredQT          ( TComDataCU* pcCU, 
-                                  TComYuv*    pcOrgYuv, 
-                                  TComYuv*    pcPredYuv, 
-                                  TComYuv*    pcResiYuv, 
+  Void  estIntraPredLumaQT      ( TComDataCU* pcCU,
+                                  TComYuv*    pcOrgYuv,
+                                  TComYuv*    pcPredYuv,
+                                  TComYuv*    pcResiYuv,
                                   TComYuv*    pcRecoYuv,
-                                  UInt&       ruiDistC,
-                                  Bool        bLumaOnly
+                                  Pel         resiLuma[NUMBER_OF_STORED_RESIDUAL_TYPES][MAX_CU_SIZE * MAX_CU_SIZE]
 #if H_3D_DIM
                                 , Bool        bOnlyIVP
 #endif
-                                );
-  Void  estIntraPredChromaQT    ( TComDataCU* pcCU, 
-                                  TComYuv*    pcOrgYuv, 
-                                  TComYuv*    pcPredYuv, 
-                                  TComYuv*    pcResiYuv, 
+                                  DEBUG_STRING_FN_DECLARE(sDebug));
+
+  Void  estIntraPredChromaQT    ( TComDataCU* pcCU,
+                                  TComYuv*    pcOrgYuv,
+                                  TComYuv*    pcPredYuv,
+                                  TComYuv*    pcResiYuv,
                                   TComYuv*    pcRecoYuv,
-                                  UInt        uiPreCalcDistC );
+                                  Pel         resiLuma[NUMBER_OF_STORED_RESIDUAL_TYPES][MAX_CU_SIZE * MAX_CU_SIZE]
+                                  DEBUG_STRING_FN_DECLARE(sDebug));
 #if H_3D
   Void  estIntraPredDIS        ( TComDataCU* pcCU, 
@@ -200,13 +200,15 @@
                                  Bool        bLumaOnly );
 #endif  
+
   /// encoder estimation - inter prediction (non-skip)
   Void predInterSearch          ( TComDataCU* pcCU,
                                   TComYuv*    pcOrgYuv,
-                                  TComYuv*&   rpcPredYuv,
-                                  TComYuv*&   rpcResiYuv,
-                                  TComYuv*&   rpcRecoYuv,
+                                  TComYuv*    pcPredYuv,
+                                  TComYuv*    pcResiYuv,
+                                  TComYuv*    pcRecoYuv
 #if H_3D_FAST_TEXTURE_ENCODING
                                   Bool        bFMD,
 #endif
+                                  DEBUG_STRING_FN_DECLARE(sDebug),
                                   Bool        bUseRes = false
 #if AMP_MRG
@@ -214,13 +216,14 @@
 #endif
                                 );
-  
+
   /// encode residual and compute rd-cost for inter mode
   Void encodeResAndCalcRdInterCU( TComDataCU* pcCU,
                                   TComYuv*    pcYuvOrg,
                                   TComYuv*    pcYuvPred,
-                                  TComYuv*&   rpcYuvResi,
-                                  TComYuv*&   rpcYuvResiBest,
-                                  TComYuv*&   rpcYuvRec,
-                                  Bool        bSkipRes );
+                                  TComYuv*    pcYuvResi,
+                                  TComYuv*    pcYuvResiBest,
+                                  TComYuv*    pcYuvRec,
+                                  Bool        bSkipResidual
+                                  DEBUG_STRING_FN_DECLARE(sDebug) );
 #if H_3D_INTER_SDC
   Void encodeResAndCalcRdInterSDCCU( TComDataCU* pcCU,
@@ -232,25 +235,22 @@
     const UInt uiDepth );
 #endif
+
   /// set ME search range
-  Void setAdaptiveSearchRange   ( Int iDir, Int iRefIdx, Int iSearchRange) { m_aaiAdaptSR[iDir][iRefIdx] = iSearchRange; }
-  
-  Void xEncPCM    (TComDataCU* pcCU, UInt uiAbsPartIdx, Pel* piOrg, Pel* piPCM, Pel* piPred, Pel* piResi, Pel* piReco, UInt uiStride, UInt uiWidth, UInt uiHeight, TextType eText);
-  Void IPCMSearch (TComDataCU* pcCU, TComYuv* pcOrgYuv, TComYuv*& rpcPredYuv, TComYuv*& rpcResiYuv, TComYuv*& rpcRecoYuv );
+  Void setAdaptiveSearchRange   ( Int iDir, Int iRefIdx, Int iSearchRange) { assert(iDir < MAX_NUM_REF_LIST_ADAPT_SR && iRefIdx<Int(MAX_IDX_ADAPT_SR)); m_aaiAdaptSR[iDir][iRefIdx] = iSearchRange; }
+
+  Void xEncPCM    (TComDataCU* pcCU, UInt uiAbsPartIdx, Pel* piOrg, Pel* piPCM, Pel* piPred, Pel* piResi, Pel* piReco, UInt uiStride, UInt uiWidth, UInt uiHeight, const ComponentID compID );
+  Void IPCMSearch (TComDataCU* pcCU, TComYuv* pcOrgYuv, TComYuv* rpcPredYuv, TComYuv* rpcResiYuv, TComYuv* rpcRecoYuv );
 protected:
-  
+
   // -------------------------------------------------------------------------------------------------------------------
   // Intra search
   // -------------------------------------------------------------------------------------------------------------------
-  
-  Void  xEncSubdivCbfQT           ( TComDataCU*  pcCU,
-                                    UInt         uiTrDepth,
-                                    UInt         uiAbsPartIdx,
+
+  Void  xEncSubdivCbfQT           ( TComTU      &rTu,
                                     Bool         bLuma,
                                     Bool         bChroma );
 
-  Void  xEncCoeffQT               ( TComDataCU*  pcCU,
-                                    UInt         uiTrDepth,
-                                    UInt         uiAbsPartIdx,
-                                    TextType     eTextType,
+  Void  xEncCoeffQT               ( TComTU &rTu,
+                                    ComponentID  component,
                                     Bool         bRealCoeff );
   Void  xEncIntraHeader           ( TComDataCU*  pcCU,
@@ -259,99 +259,87 @@
                                     Bool         bLuma,
                                     Bool         bChroma );
-  UInt  xGetIntraBitsQT           ( TComDataCU*  pcCU,
-                                    UInt         uiTrDepth,
-                                    UInt         uiAbsPartIdx,
+  UInt  xGetIntraBitsQT           ( TComTU &rTu,
                                     Bool         bLuma,
                                     Bool         bChroma,
                                     Bool         bRealCoeff );
-  UInt  xGetIntraBitsQTChroma    ( TComDataCU*   pcCU,
-                                   UInt          uiTrDepth,
-                                   UInt          uiAbsPartIdx,
-                                   UInt          uiChromaId,
+
+  UInt  xGetIntraBitsQTChroma    ( TComTU &rTu,
+                                   ComponentID compID,
                                    Bool          bRealCoeff );
-  
-  Void  xIntraCodingLumaBlk       ( TComDataCU*  pcCU,
-                                    UInt         uiTrDepth,
-                                    UInt         uiAbsPartIdx,
-                                    TComYuv*     pcOrgYuv, 
-                                    TComYuv*     pcPredYuv, 
-                                    TComYuv*     pcResiYuv, 
-#if H_3D_VSO
+
+  Void  xIntraCodingTUBlock       (       TComYuv*      pcOrgYuv,
+                                          TComYuv*      pcPredYuv,
+                                          TComYuv*      pcResiYuv,
+                                          Pel           resiLuma[NUMBER_OF_STORED_RESIDUAL_TYPES][MAX_CU_SIZE * MAX_CU_SIZE],
+                                    const Bool          checkCrossCPrediction,
+#if NH_3D_VSO
                                     Dist&        ruiDist,
 #else
-                                    UInt&        ruiDist,
-#endif
-                                    Int         default0Save1Load2 = 0
+                                    Distortion&   ruiDist,
+#endif
+const ComponentID   compID,
+                                          TComTU        &rTu
+                                    DEBUG_STRING_FN_DECLARE(sTest)
+                                         ,Int           default0Save1Load2 = 0
 #if H_3D_DIM_ENC
                                   , Bool          zeroResi = false
 #endif
-                                    );
-  Void  xIntraCodingChromaBlk     ( TComDataCU*  pcCU,
-                                    UInt         uiTrDepth,
-                                    UInt         uiAbsPartIdx,
-                                    TComYuv*     pcOrgYuv, 
-                                    TComYuv*     pcPredYuv, 
-                                    TComYuv*     pcResiYuv, 
-                                    UInt&        ruiDist,
-                                    UInt         uiChromaId,
-                                    Int          default0Save1Load2 = 0 );
-
-  Void  xRecurIntraCodingQT       ( TComDataCU*  pcCU, 
-                                    UInt         uiTrDepth,
-                                    UInt         uiAbsPartIdx, 
-                                    Bool         bLumaOnly,
-                                    TComYuv*     pcOrgYuv, 
-                                    TComYuv*     pcPredYuv, 
-                                    TComYuv*     pcResiYuv, 
-#if H_3D_VSO
+                                   );
+
+  Void  xRecurIntraCodingLumaQT   ( TComYuv*    pcOrgYuv,
+                                    TComYuv*    pcPredYuv,
+                                    TComYuv*    pcResiYuv,
+                                    Pel         resiLuma[NUMBER_OF_STORED_RESIDUAL_TYPES][MAX_CU_SIZE * MAX_CU_SIZE],
+#if NH_3D_VSO
                                     Dist&        ruiDistY,
 #else
-                                    UInt&        ruiDistY,
-#endif
-                                    UInt&        ruiDistC,
+                                    Distortion& ruiDistY,
+#endif
 #if HHI_RQT_INTRA_SPEEDUP
-                                   Bool         bCheckFirst,
-#endif
-                                   Double&      dRDCost
+                                    Bool         bCheckFirst,
+#endif
+                                    Double&      dRDCost,
 #if H_3D_DIM_ENC
                                    , Bool          zeroResi = false
 #endif
-                                   );
-  
-  Void  xSetIntraResultQT         ( TComDataCU*  pcCU,
-                                    UInt         uiTrDepth,
-                                    UInt         uiAbsPartIdx,
-                                    Bool         bLumaOnly,
-                                    TComYuv*     pcRecoYuv );
-  
-  Void  xRecurIntraChromaCodingQT ( TComDataCU*  pcCU, 
-                                    UInt         uiTrDepth,
-                                    UInt         uiAbsPartIdx, 
-                                    TComYuv*     pcOrgYuv, 
-                                    TComYuv*     pcPredYuv, 
-                                    TComYuv*     pcResiYuv, 
-                                    UInt&        ruiDist );
-  Void  xSetIntraResultChromaQT   ( TComDataCU*  pcCU,
-                                    UInt         uiTrDepth,
-                                    UInt         uiAbsPartIdx,
-                                    TComYuv*     pcRecoYuv );
-  
-  Void  xStoreIntraResultQT       ( TComDataCU*  pcCU,
-                                    UInt         uiTrDepth,
-                                    UInt         uiAbsPartIdx,
-                                    Bool         bLumaOnly );
-  Void  xLoadIntraResultQT        ( TComDataCU*  pcCU,
-                                    UInt         uiTrDepth,
-                                    UInt         uiAbsPartIdx,
-                                    Bool         bLumaOnly );
-  Void xStoreIntraResultChromaQT  ( TComDataCU*  pcCU,
-                                    UInt         uiTrDepth,
-                                    UInt         uiAbsPartIdx,
-                                    UInt         stateU0V1Both2 );
-  Void xLoadIntraResultChromaQT   ( TComDataCU*  pcCU,
-                                    UInt         uiTrDepth,
-                                    UInt         uiAbsPartIdx,
-                                    UInt         stateU0V1Both2 );
-
+                                    TComTU      &rTu
+                                    DEBUG_STRING_FN_DECLARE(sDebug));
+
+  Void  xSetIntraResultLumaQT     ( TComYuv*     pcRecoYuv,
+                                    TComTU &rTu);
+
+  Void xStoreCrossComponentPredictionResult  (       Pel    *pResiLuma,
+                                               const Pel    *pBestLuma,
+                                                     TComTU &rTu,
+                                               const Int     xOffset,
+                                               const Int     yOffset,
+                                               const Int     strideResi,
+                                               const Int     strideBest );
+
+  Char xCalcCrossComponentPredictionAlpha    (       TComTU &rTu,
+                                               const ComponentID compID,
+                                               const Pel*        piResiL,
+                                               const Pel*        piResiC,
+                                               const Int         width,
+                                               const Int         height,
+                                               const Int         strideL,
+                                               const Int         strideC );
+
+  Void  xRecurIntraChromaCodingQT ( TComYuv*    pcOrgYuv,
+                                    TComYuv*    pcPredYuv,
+                                    TComYuv*    pcResiYuv,
+                                    Pel         resiLuma[NUMBER_OF_STORED_RESIDUAL_TYPES][MAX_CU_SIZE * MAX_CU_SIZE],
+#if NH_3D_VSO
+                                    Dist&       ruiDist,
+#else
+                                    Distortion& ruiDist,
+#endif
+                                    TComTU      &rTu
+                                    DEBUG_STRING_FN_DECLARE(sDebug));
+
+  Void  xSetIntraResultChromaQT   ( TComYuv*    pcRecoYuv, TComTU &rTu);
+
+  Void  xStoreIntraResultQT       ( const ComponentID compID, TComTU &rTu);
+  Void  xLoadIntraResultQT        ( const ComponentID compID, TComTU &rTu);
 #if H_3D
   Void xIntraCodingDIS           ( TComDataCU* pcCU, UInt uiAbsPartIdx, TComYuv* pcOrgYuv, TComYuv* pcPredYuv, Dist& ruiDist, Double& dRDCost, UInt uiPredMode );
@@ -371,8 +359,9 @@
 #endif
 
+
   // -------------------------------------------------------------------------------------------------------------------
   // Inter search (AMP)
   // -------------------------------------------------------------------------------------------------------------------
-  
+
   Void xEstimateMvPredAMVP        ( TComDataCU* pcCU,
                                     TComYuv*    pcOrgYuv,
@@ -382,10 +371,7 @@
                                     TComMv&     rcMvPred,
                                     Bool        bFilled = false
-                                  , UInt*       puiDistBiP = NULL
-                                  #if ZERO_MVD_EST
-                                  , UInt*       puiDist = NULL
-                                  #endif
+                                  , Distortion* puiDistBiP = NULL
                                      );
-  
+
   Void xCheckBestMVP              ( TComDataCU* pcCU,
                                     RefPicList  eRefPicList,
@@ -394,8 +380,7 @@
                                     Int&        riMVPIdx,
                                     UInt&       ruiBits,
-                                    UInt&       ruiCost );
-  
-  UInt xGetTemplateCost           ( TComDataCU* pcCU,
-                                    UInt        uiPartIdx,
+                                    Distortion& ruiCost );
+
+  Distortion xGetTemplateCost    ( TComDataCU*  pcCU,
                                     UInt        uiPartAddr,
                                     TComYuv*    pcOrgYuv,
@@ -408,23 +393,20 @@
                                     Int         iSizeX,
                                     Int         iSizeY
-                                  #if ZERO_MVD_EST
-                                  , UInt&       ruiDist
-                                  #endif
                                    );
-  
-  
+
+
   Void xCopyAMVPInfo              ( AMVPInfo*   pSrc, AMVPInfo* pDst );
   UInt xGetMvpIdxBits             ( Int iIdx, Int iNum );
   Void xGetBlkBits                ( PartSize  eCUMode, Bool bPSlice, Int iPartIdx,  UInt uiLastMode, UInt uiBlkBit[3]);
-  
-  Void xMergeEstimation           ( TComDataCU*     pcCU,
-                                    TComYuv*        pcYuvOrg,
-                                    Int             iPartIdx,
-                                    UInt&           uiInterDir,
-                                    TComMvField*    pacMvField,
-                                    UInt&           uiMergeIndex,
-                                    UInt&           ruiCost
-                                  , TComMvField* cMvFieldNeighbours,  
-                                    UChar* uhInterDirNeighbours
+
+  Void xMergeEstimation           ( TComDataCU*  pcCU,
+                                    TComYuv*     pcYuvOrg,
+                                    Int          iPartIdx,
+                                    UInt&        uiInterDir,
+                                    TComMvField* pacMvField,
+                                    UInt&        uiMergeIndex,
+                                    Distortion&  ruiCost,
+                                    TComMvField* cMvFieldNeighbours,
+                                    UChar*       uhInterDirNeighbours,
 #if H_3D_VSP
                                   , Int* vspFlag
